Summary: GNU Compiler System
Name: gcc
Version: 2.95.3
Release: 1
Serial: 1
Group: Development/Languages
Copyright: GPL
Url: http://gcc.gnu.org/
Packager: Hao Li <hli@wag.caltech.edu>
Source: ftp://gcc.gnu.org/pub/gcc/releases/gcc-%{version}/gcc-%{version}.tar.bz2
Buildroot: /var/tmp/%{name}-root

%description
A compiler aimed at integrating all the optimizations and features
necessary for a high-performance and stable development environment.

This package contains all the components of gcc, including c, c++, objc,
g77, chill and java. C++ shared libraries and headers which usually go
to libstdc++ and libstdc++-devel are also bundled in this package.


%prep
%setup -q


%build
NCPU=`egrep -c ^processor /proc/cpuinfo`
export MAKE="make -j$NCPU"

rm -rf obj-i686-redhat-linux
mkdir  obj-i686-redhat-linux
cd     obj-i686-redhat-linux

CFLAGS='-O' \
LIBCFLAGS='-g -O2' \
LIBCXXFLAGS='-g -O2 -fno-implicit-templates' \
MAKEINFOFLAGS='--no-split' \
../configure --prefix=/usr --enable-shared --enable-threads i686-redhat-linux
$MAKE bootstrap-lean

# Remake info files with '--no-split'. Too tricky to do it above.
find . -name \*.info\* -exec rm -f {} \;
make do-info MAKEINFOFLAGS='--no-split'


%install
rm -rf $RPM_BUILD_ROOT
cd obj-i686-redhat-linux
make prefix=$RPM_BUILD_ROOT/usr install

# Replace duplicated files with symlinks; also add some more symlinks
ln -sf i686-redhat-linux-gcc	$RPM_BUILD_ROOT/usr/bin/gcc
ln -sf gcc			$RPM_BUILD_ROOT/usr/bin/cc
ln -sf g++			$RPM_BUILD_ROOT/usr/bin/c++
ln -sf g77			$RPM_BUILD_ROOT/usr/bin/f77
ln -sf gcc.1			$RPM_BUILD_ROOT/usr/man/man1/cc.1
ln -sf g++.1			$RPM_BUILD_ROOT/usr/man/man1/c++.1
ln -sf g77.1			$RPM_BUILD_ROOT/usr/man/man1/f77.1

# /lib/cpp
mkdir -p $RPM_BUILD_ROOT/lib
ln -s ../usr/bin/cpp		$RPM_BUILD_ROOT/lib/cpp
ln -sf cccp.1 			$RPM_BUILD_ROOT/usr/man/man1/cpp.1

# /usr/lib/libiberty.a is already provided by binutils
rm -f $RPM_BUILD_ROOT/usr/lib/libiberty.a


%post
/sbin/install-info /usr/info/chill.info.gz /usr/info/dir
/sbin/install-info /usr/info/cpp.info.gz /usr/info/dir
/sbin/install-info /usr/info/gcc.info.gz /usr/info/dir
/sbin/install-info /usr/info/g77.info.gz /usr/info/dir
/sbin/ldconfig

%preun
if [ $1 = 0 ]; then
    /sbin/install-info --delete /usr/info/chill.info.gz /usr/info/dir
    /sbin/install-info --delete /usr/info/cpp.info.gz /usr/info/dir
    /sbin/install-info --delete /usr/info/gcc.info.gz /usr/info/dir
    /sbin/install-info --delete /usr/info/g77.info.gz /usr/info/dir
fi

%postun
/sbin/ldconfig


%files
%defattr(-,root,root)
%doc COPYING COPYING.LIB ChangeLog FAQ MAINTAINERS README install
/lib/cpp
/usr/bin/*
/usr/include/g++-3
/usr/info/*
/usr/lib/gcc-lib
/usr/lib/libstdc++*
/usr/man/man*/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Wed Jan  3 2001 Hao Li <hli@wag.caltech.edu>
- gcc-2.95.3.test1
- Decided to use /usr/lib/libiberty.a from binutils so this file from gcc 
  is removed.
- Several files under /usr/bin generated by "make install" are duplicated
  so I changed them from real file to symbolic links. These include:
  	gcc -> i686-redhat-linux-gcc 
  	c++ -> g++
  These two links under /usr/bin are added:
  	cc  -> gcc
	f77 -> g77

